----------------------------------------------------------------------------------
-- Company: University of Connecticut
-- Engineer: Brendan Krueger
-- 
-- Create Date:    17:45:50 06/28/2007 
-- Design Name: Temperature Sensor Controller
-- Module Name:    Temp_cont - Temp_cont_arch 
-- Project Name: Temperature Sensor
-- Target Devices: Xilinx Spartan-3A
-- Tool versions: Xilinx ISE WebPACK 9.1.03i
-- Description: Controller for Temperature Sensor
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Temp_cont is
    Port ( CLK : in  STD_LOGIC;								-- clock
           iRST : in  STD_LOGIC;								-- reset
           Go : in  STD_LOGIC;								-- pulse to start
           Din : in  STD_LOGIC;								-- serial data in
			  SCLK: out STD_LOGIC;								-- serial clock output
			  CE : out STD_LOGIC;								-- chip enable
           Q : out  STD_LOGIC_VECTOR (9 downto 0));	-- parallel data out
end Temp_cont;

architecture Temp_cont_arch of Temp_cont is

	component Temp_cntr
		Port (	CLK : in  STD_LOGIC;
					RST : in  STD_LOGIC;
					Go : in  STD_LOGIC;
					CE : out STD_LOGIC;
					En : out  STD_LOGIC);
	end component;
	
	component Temp_delay
		Port (	CLK : in  STD_LOGIC;
					SigIn : in  STD_LOGIC;
					SigOut : out  STD_LOGIC);
	end component;
	
	component Temp_cshift
		Port (	CLK : in  STD_LOGIC;
					RST : in  STD_LOGIC;
					En : in  STD_LOGIC;
					Din : in  STD_LOGIC;
					Q : out  STD_LOGIC_VECTOR (9 downto 0));
	end component;
	
	signal enable : STD_LOGIC;
	signal delEn : STD_LOGIC;

begin

	u1: Temp_cntr   port map (CLK, iRST, Go, CE, enable);
	u2: Temp_cshift port map (CLK, iRST, delEn, Din, Q);
	u3: Temp_delay  port map (CLK, enable, delEn);
	
	SCLK <= CLK;

end Temp_cont_arch;

