----------------------------------------------------------------------------------
-- Company: University of Connecticut
-- Engineer: Brendan Krueger
-- 
-- Create Date:    10:07:35 06/29/2007 
-- Design Name: Single-Cycle Delayer for Temperature Sensor Controller
-- Module Name:    Temp_delay - Temp_delay_arch 
-- Project Name: Temperature Sensor
-- Target Devices: Xilinx Spartan-3A
-- Tool versions: Xilinx ISE WebPACK 9.1.03i
-- Description: Delays a signal by one clock cycle
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Temp_delay is
    Port ( CLK : in  STD_LOGIC;			-- clock
           SigIn : in  STD_LOGIC;		-- signal to be delayed
           SigOut : out  STD_LOGIC);	-- signal after being delayed
end Temp_delay;

architecture Temp_delay_arch of Temp_delay is

	signal temp1 : STD_LOGIC;

begin

	delayer : process (CLK, SigIn, temp1)
	-- flip-flop to delay being clocked into next block
	begin
		if (rising_edge(CLK)) then
			temp1 <= SigIn;
		else
			temp1 <= temp1;
		end if;
	end process delayer;
	
	SigOut <= temp1;

end Temp_delay_arch;

